/*
  Use of this code is subject to the terms of the Phase 1 Cosm License.
  Any other use of this code violates the terms of the license.
*/

#include "cosm.h"

s32 v3Test( s32 * failed_module, s32 * failed_test, s32 module_num )
{
  /* Run all the module test functions */
  s32 err;

  err = 0;
  *failed_module = 0;
  *failed_test = 0;

  switch ( module_num )
  {
    case 0:
      if ( ( err = v3_TestCosmMath() ) != V3_PASS )
      {
        *failed_module = -1;
        *failed_test = err;
        return( -1 );
      }
      if ( ( err = v3_TestCosmTask() ) != V3_PASS )
      {
        *failed_module = -2;
        *failed_test = err;
        return( -2 );
      }
      if ( ( err = v3_TestCosmMem() ) != V3_PASS )
      {
        *failed_module = -3;
        *failed_test = err;
        return( -3 );
      }
      if ( ( err = v3_TestCosmFile() ) != V3_PASS )
      {
        *failed_module = -4;
        *failed_test = err;
        return( -4 );
      }
      if ( ( err = v3_TestCosmIO() ) != V3_PASS )
      {
        *failed_module = -5;
        *failed_test = err;
        return( -5 );
      }
      if ( ( err = v3_TestCosmNet() ) != V3_PASS )
      {
        *failed_module = -6;
        *failed_test = err;
        return( -6 );
      }
      if ( ( err = v3_TestBuffer() ) != V3_PASS )
      {
        *failed_module = -7;
        *failed_test = err;
        return( -7 );
      }
      if ( ( err = v3_TestEmail() ) != V3_PASS )
      {
        *failed_module = -8;
        *failed_test = err;
        return( -8 );
      }
      if ( ( err = v3_TestLog() ) != V3_PASS )
      {
        *failed_module = -9;
        *failed_test = err;
        return( -9 );
      }
      if ( ( err = v3_TestConfig() ) != V3_PASS )
      {
        *failed_module = -10;
        *failed_test = err;
        return( -10 );
      }
      if ( ( err = v3_TestSecurity() ) != V3_PASS )
      {
        *failed_module = -11;
        *failed_test = err;
        return( -11 );
      }
      if ( ( err = v3_TestCosmTime() ) != V3_PASS )
      {
        *failed_module = -12;
        *failed_test = err;
        return( -12 );
      }
      if ( ( err = v3_TestSpeed() ) != V3_PASS )
      {
        *failed_module = -13;
        *failed_test = err;
        return( -13 );
      }
      if ( ( err = v3_TestCompress() ) != V3_PASS )
      {
        *failed_module = -14;
        *failed_test = err;
        return( -14 );
      }
      if ( ( err = v3_TestLanguage() ) != V3_PASS )
      {
        *failed_module = -15;
        *failed_test = err;
        return( -15 );
      }
      if ( ( err = v3_TestCosmGUI() ) != V3_PASS )
      {
        *failed_module = -16;
        *failed_test = err;
        return( -16 );
      }
    case -1:
      if ( ( err = v3_TestCosmMath() ) != V3_PASS )
      {
        *failed_module = -1;
        *failed_test = err;
        return( -1 );
      }
      break;
    case -2:
      if ( ( err = v3_TestCosmTask() ) != V3_PASS )
      {
        *failed_module = -2;
        *failed_test = err;
        return( -2 );
      }
      break;
    case -3:
      if ( ( err = v3_TestCosmMem() ) != V3_PASS )
      {
        *failed_module = -3;
        *failed_test = err;
        return( -3 );
      }
      break;
    case -4:
      if ( ( err = v3_TestCosmFile() ) != V3_PASS )
      {
        *failed_module = -4;
        *failed_test = err;
        return( -4 );
      }
      break;
    case -5:
      if ( ( err = v3_TestCosmIO() ) != V3_PASS )
      {
        *failed_module = -5;
        *failed_test = err;
        return( -5 );
      }
      break;
    case -6:
      if ( ( err = v3_TestCosmNet() ) != V3_PASS )
      {
        *failed_module = -6;
        *failed_test = err;
        return( -6 );
      }
      break;
    case -7:
      if ( ( err = v3_TestBuffer() ) != V3_PASS )
      {
        *failed_module = -7;
        *failed_test = err;
        return( -7 );
      }
      break;
    case -8:
      if ( ( err = v3_TestEmail() ) != V3_PASS )
      {
        *failed_module = -8;
        *failed_test = err;
        return( -8 );
      }
      break;
    case -9:
      if ( ( err = v3_TestLog() ) != V3_PASS )
      {
        *failed_module = -9;
        *failed_test = err;
        return( -9 );
      }
      break;
    case -10:
      if ( ( err = v3_TestConfig() ) != V3_PASS )
      {
        *failed_module = -10;
        *failed_test = err;
        return( -10 );
      }
      break;
    case -11:
      if ( ( err = v3_TestSecurity() ) != V3_PASS )
      {
        *failed_module = -11;
        *failed_test = err;
        return( -11 );
      }
      break;
    case -12:
      if ( ( err = v3_TestCosmTime() ) != V3_PASS )
      {
        *failed_module = -12;
        *failed_test = err;
        return( -12 );
      }
      break;
    case -13:
      if ( ( err = v3_TestSpeed() ) != V3_PASS )
      {
        *failed_module = -13;
        *failed_test = err;
        return( -13 );
      }
      break;
    case -14:
      if ( ( err = v3_TestCompress() ) != V3_PASS )
      {
        *failed_module = -14;
        *failed_test = err;
        return( -14 );
      }
      break;
    case -15:
      if ( ( err = v3_TestLanguage() ) != V3_PASS )
      {
        *failed_module = -15;
        *failed_test = err;
        return( -15 );
      }
      break;
    case -16:
      if ( ( err = v3_TestCosmGUI() ) != V3_PASS )
      {
        *failed_module = -16;
        *failed_test = err;
        return( -16 );
      }
      break;
    default:
      return( V3_PASS );
  }

  return( V3_PASS );
}
