/*
  Use of this code is subject to the terms of the Phase 1 Cosm License.
  Any other use of this code violates the terms of the license.
*/

#ifndef V3_SPEED_H
#define V3_SPEED_H

#include "cputypes.h"

/* testing */

u64 v3SpeedFloat( void );
  /*
    Benchmark IEEE floating point unit performance. Focus on 64bit math.
    Returns: Floating point performance where Intel Pentium-100 = 100, on
      failure return 0.
  */

u64 v3SpeedInt( void );
  /*
    Benchmark integer unit performance.
    Returns: Integer performance where Intel Pentium-100 = 100, on
      failure return 0.
  */

s32 v3_SpeedInterval( v3_time * times );
  /*
    Set times[0] to the current time, and times[1] to the time elapsed since
    the last call.
    Returns: V3_PASS on success, or V3_FAIL on failure.
  */

s32 v3_TestSpeed( void );
  /*
    Test functions in this header.
    Returns: V3_PASS on success, or a negative number corresponding to the
      test that failed.
  */

#endif
